open Jakref_parser ;;
open Jakref_lexer ;;
open Jakref_basics;;
open Printf ;;
open Parsing;;
open List;;
open Lexing;;

let ext=".dj";;

let lex b = next_token b

let execute_jakarta_parse in_chan=
  let lexbuf = (from_channel in_chan) in 
    while true do (command lex lexbuf)
    done ;;



let parse_function name = 
  if Sys.file_exists (name) 
  then  
    try 
      let oc = (open_in name) in
      let _ = (set_current_filename (String.sub name  0 ((String.length name)-3))) in
      let _ = (file_output name) in
	(execute_jakarta_parse oc) 
    with   
	End_ok ->
	  produce_output ();
	  prerr_string ("\nthe file "^name^" was processed \n\n");
	  flush stderr 
  else 
    (prerr_string ("\nthe file "^name^" does not exist \n\n");
     flush stderr)    
;; 

let output_option  (st:string) = 
  (set_outputfile st;
    prerr_string ("output file = "^st^"\n");
    flush stderr);;

let usage_msg = 
"Command line usage : \n
\t\"jakartag [-o output_filename] [list of input files]\"
\n or\n
\t\"jakartag {-h|--help}\" \n
";;


let print_banner () = (prerr_string usage_msg;
		       flush stderr) ;;
    
let speclist= 
  [
   ("-o", Arg.String output_option, 
    "\t\tset the default output to \"output_filename\".dj\n\t\t(standard output otherwise)");

   ("-h", Arg.Unit print_banner, 
    "\t\tprint this message and ignore other options");
   
   ("--help", Arg.Unit print_banner, 
    "\tprint this message and ignore other options");]
;;
     

let  jakref_banner =  
  "jakref - the references table builder for jakartadoc, the documentation tool for JaKarTa.\n"^
  "Copyright (C) 2003 - 2004 Daniela JUNHO ANDRADE and Simo MELO de SOUSA\n"


let main () =
 try 
  let _ = (prerr_string jakref_banner;
	 flush stderr )
  in
  (let largv =  (Array.to_list Sys.argv) in
  if ((List.mem "-h" largv) ||  
	 (List.mem "--help" largv))
  then 
	   (
	    prerr_string usage_msg;
	    flush stderr
	   )
  else(
	  let number_of_argument = Array.length (Sys.argv) in
	  if number_of_argument = 1
	  then (raise End_ok )
	  else (
	   (Arg.parse speclist parse_function usage_msg);
	   prerr_string"\nDone \n";
	   flush stderr ;exit 0)))
 with 
    End_ok              -> 
     prerr_string"\nDone \n\n";flush stderr; exit 0
  | ex -> 
     prerr_string ("\n Despite "^(Printexc.to_string ex)^"...Done \n\n");flush stderr ;exit 1;; 

(*start of the aplication*)


main () ;; 

 (* %%% Local Variables: *)
 (* %%% igrep-files-var: "jakref_basic.ml jakref_lexer.mll jakref_parser.mly jakref.ml" *)
 (* %%% compile-command: "make -C .. jakref.cmo" *)
 (* %%% indent-tabs-mode: nil *)
 (* %%% tab-width: 1 *)
 (* %%% indent-tabs-mode: nil *)
 (* %%% indent-tabs-mode: nil *)
 (* %%% tuareg-default-indent:1 *)
 (* %%% tuareg-begin-indent:1 *)
 (* %%% tuareg-let-indent:1 *)
 (* %%% tuareg-match-indent:-1 *)
 (* %%% tuareg-try-indent:1 *)
 (* %%% tuareg-with-indent:1 *)
 (* %%% tuareg-rule-indent:1 *)
 (* %%% fill-column: 85 *)
 (* %%% End: *)


 
